<?php
/**********************************************************************************
* Contact.template.php                                                            *
***********************************************************************************
*                                                                                 *
* Template file for 'Contact Form' modification.                                  *
*                                                                                 *
* Copyright (c) 2008 by Deprecated (at) Earthlink (dot) net. All rights reserved. *
* Redistribution prohibited except at SimpleMachines.org                          *
*                                                                                 *
**********************************************************************************/

function template_main()
{
	global $context, $webmaster_email, $userinfo, $context, $scripturl, $modSettings, $txt;

	echo theme_linktree();

	echo '
	<div class="tborder" style="margin-top: 1ex; width: 80%; margin-left: auto; margin-right: auto;">
		<div class="helpmenu titlebg" style="padding: 4px;">
			', $context['page_title'], '
		</div>
		<form action="', $scripturl, '?action=contact" method="post" style="margin: 16px">';

//--------------------------------------------------------------------------------------------------
//		Name
//--------------------------------------------------------------------------------------------------
	echo '
			<div style="padding-bottom: 6px;">
				<label for="name"><span class="normaltext">',
				$txt['contact_form_label_name'],
				'<span class="smalltext"',
				empty($modSettings['contact_form_require_name']) ? '> ' . $txt['contact_form_field_optional'] : ' style="color: red;"> ' . $txt['contact_form_field_required'],
				'</span></span><br />
				<input ';
	if (isset($context['contact_form_message_sent'])) echo 'readonly="readonly" style="background-color: #F0F0F0;" ';
	if (isset($_POST['name'])) echo 'value="', trim($_POST['name']), '" ';
	echo 'type="text" size="24" name="name" id="name2"';
	if (isset($context['contact_form_error_no_name']) && isset($_POST['submit']))
	{
		echo ' style="border-style: solid; border-color: red;" />
				</label> <span class="smalltext" style="color: red;">', $txt['contact_form_error_no_name'], '</span>';
	}
	else echo ' />
				</label>';
	echo '
			</div>';

//--------------------------------------------------------------------------------------------------
//		Email address
//--------------------------------------------------------------------------------------------------
	echo'
			<div style="padding-bottom: 6px;">
				<label for="email"><span class="normaltext">',
				$txt['contact_form_label_email'],
				'<span class="smalltext"',
				empty($modSettings['contact_form_require_email']) ? '> ' . $txt['contact_form_field_optional_email'] : ' style="color: red;"> ' . $txt['contact_form_field_required'],
				'</span></span><br />
				<input ';
	if (isset($context['contact_form_message_sent'])) echo 'readonly="readonly" style="background-color: #F0F0F0;" ';
	if (isset($_POST['email'])) echo 'value="', trim($_POST['email']), '" ';
	echo 'type="text" size="24" name="email" id="email"';
	if (isset($context['contact_form_error_no_email']) && isset($_POST['submit']))
	{
		echo ' style="border-style: solid; border-color: red;" />
				</label> <span class="smalltext" style="color: red;">', $txt['contact_form_error_no_email'], '</span>';
	}
	else if (isset($context['contact_form_error_invalid_email']) && isset($_POST['submit']))
	{
		echo ' style="border-style: solid; border-color: red;" />
				</label> <span class="smalltext" style="color: red;">', $txt['contact_form_error_invalid_email'], '</span>';
	}
	else echo ' />
				</label>';
	echo '
			</div>';

//--------------------------------------------------------------------------------------------------
//		Subject line
//--------------------------------------------------------------------------------------------------
	echo '
			<div style="padding-bottom: 6px;">
				<label for="subject"><span class="normaltext">',
				$txt['contact_form_label_subject'],
				'<span class="smalltext"',
				empty($modSettings['contact_form_require_subject']) ? '> ' . $txt['contact_form_field_optional'] : ' style="color: red;"> ' . $txt['contact_form_field_required'],
				'</span></span><br />
				<input ';
	if (isset($context['contact_form_message_sent'])) echo 'readonly="readonly" style="background-color: #F0F0F0;" ';
	if (isset($_POST['subject'])) echo 'value="', trim($_POST['subject']), '" ';
	echo 'type="text" size="24" name="subject" id="subject"';
	if (isset($context['contact_form_error_no_subject']) && isset($_POST['submit']))
	{
		echo ' style="border-style: solid; border-color: red;" />
				</label> ', '<span class="smalltext" style="color: red;">', $txt['contact_form_error_no_subject'], '</span>';
	}
	else echo ' />
				</label>';
	echo '
			</div>';

//--------------------------------------------------------------------------------------------------
//		Visual verification
//--------------------------------------------------------------------------------------------------
	if ($context['visual_verification'] || isset($context['contact_form_error_visual_verification']))
	{
		echo '
			<table class="normaltext">
				<tr>
					<td';
		if (isset($context['contact_form_error_visual_verification'])) echo ' style="border-style: solid; border-color: red; border-width: 2px;"';
		echo '>
			<span class="normaltext"><br />',
			$txt['contact_form_label_verification'],		
			'<span class="smalltext" style="color: red;"> ', $txt['contact_form_field_required'], '</span>',
			'</span><br />',
			template_control_verification($context['visual_verification_id']),
			'</td>
					<td>';
		if (isset($context['contact_form_error_visual_verification'])) echo '<span class="smalltext" style="color: red;">', $context['visual_verification_error_dscr'], '</span>';
		echo '</td>
				</tr>
			</table>';
	}

//--------------------------------------------------------------------------------------------------
//		Message
//--------------------------------------------------------------------------------------------------
	echo '
			<div>
				<label for="message"><span class="normaltext">',
				$txt['contact_form_label_message'],
				'<span class="smalltext" style="color: red;"> ', $txt['contact_form_field_required'],
				'</span><br />';
	if (isset($context['contact_form_error_no_message']) && isset($_POST['submit']))
	{
		echo '
				<textarea rows="12" cols="60" name="message" id="message" style="border-style: solid; border-color: red;"></textarea></span>
				</label>', '<span class="smalltext" style="color: red; vertical-align: top;">', $txt['contact_form_error_no_message'], '</span>';
	}
	else
	{
		echo '
				<textarea ';
		if (isset($context['contact_form_message_sent'])) echo 'readonly="readonly" style="background-color: #F0F0F0;" ';
		echo 'rows="12" cols="60" name="message" id="message">',
				isset($_POST['message']) ? trim($_POST['message']) : '',
				'</textarea></span>
				</label>';
	}
	echo '
			</div>';

//--------------------------------------------------------------------------------------------------
//		Send button or message sent status
//--------------------------------------------------------------------------------------------------

	if (isset($context['contact_form_message_sent']))
	{
		echo '
			<div style="padding-top: 10px; padding-bottom: 10px">
				<span class="normaltext"><a href="', $scripturl, '">', $txt['contact_form_message_sent'], '</a></span>
			</div>';
	}
	else if (isset($context['contact_form_message_failed']))
	{
			echo '
			<div style="padding-top: 10px; padding-bottom: 10px">
				<span class="normaltext" style="color: red;">', $txt['contact_form_error_unable_to_send'], '</span>
			</div>';
	}
	else
	{
		echo '
			<div>
				<label for="submit"><br />
				<input type="submit" name="submit" id="submit" value="', $txt['contact_form_label_submit_button'], '" />
				</label>
			</div>';
	}

	echo '
		</form>
	</div>';
}

?>